diff --git a/kernel/sched_fair_htfs.c b/kernel/sched_fair_htfs.c
new file mode 100644
index 0000000..2f2aca0
--- /dev/null
+++ b/kernel/sched_fair_htfs.c
@@ -0,0 +1,2273 @@
+/*
+ *  High Throughput Fair Scheduler Class
+ *
+ *  Copyright (C) 2011 Markus Pargmann <mpargmann@allfex.org>
+ *
+ *  Some balancing routines from the original CFS
+ *  (C) 2007 Red Hat, Inc., Ingo Molnar <mingo@redhat.com>
+ *
+ */
+
+
+#ifdef CONFIG_SCHED_FAIR_HTFS
+
+#define HTFS_WEIGHT_LVLS 50
+
+static const unsigned long bweights[HTFS_WEIGHT_LVLS] = {
+              270877,    216701,    173361,    138689,    110951,
+ /* -20 */     88761,     71755,     56483,     46273,     36291,
+ /* -15 */     29154,     23254,     18705,     14949,     11916,
+ /* -10 */      9548,      7620,      6100,      4904,      3906,
+ /*  -5 */      3121,      2501,      1991,      1586,      1277,
+ /*   0 */      1024,       820,       655,       526,       423,
+ /*   5 */       335,       272,       215,       172,       137,
+ /*  10 */       110,        87,        70,        56,        45,
+ /*  15 */        36,        29,        23,        18,        15,
+                  12,         9,         6,         3,         1
+};
+
+
+static struct htfs_rq *rq_of_pq(struct htfs_pq *pq);
+
+
+/******************************************************************************
+ * Debugging functions
+ */
+#define DBG_WAIT(seconds) { volatile long i = seconds * (1L<<10); while(i--);}
+static const int dbg_level = 0;
+#define DBG_FUNC(level) {if (dbg_level >= level) {DBG_FUNC_NOWAIT(level); DBG_WAIT(0);}}
+#define DBG_FUNC_EXT(level, arg) {if (dbg_level >= level) {DBG_FUNC_NOWAIT_EXT(level, arg); DBG_WAIT(0);}}
+
+#define DBG_PRINTK(level, args) {if (dbg_level >= level) { printk(KERN_EMERG "HTFS: %s: ", __FUNCTION__); printk args ; DBG_WAIT(0)}}
+
+#define DBG_FUNC_NOWAIT(level) {if (dbg_level >= level) {DBG_FUNC_NOWAIT_EXT(level, "");}}
+#define DBG_FUNC_NOWAIT_EXT(level, arg) {if (dbg_level >= level) {printk(KERN_EMERG "HTFS: %s %s\n", __FUNCTION__, arg);}}
+
+#define DBG_ASSERT(condition) {if (unlikely(!(condition))) {printk(KERN_EMERG "HTFS ASSERT FAILED: %s function: %s line: %d\n", #condition, __FUNCTION__, __LINE__); DBG_WAIT(1000000);}}
+
+static void pq_dump(struct htfs_pq *pq, int level)
+{
+	struct list_head *lh = pq->queue.next;
+	if (level > dbg_level)
+		return;
+	while (lh != &pq->queue) {
+		struct sched_entity *se = list_entry(lh, struct sched_entity,
+				htfs_pq_item);
+		printk(KERN_EMERG "      vruntime: %lu weight: %lu "
+				"bweight: %lu inter:%lu inter_avg:%lu "
+				"load_avg: %lu\n",
+				(unsigned long)se->vruntime,
+				se->load.weight,
+				bweights[se->bw_ind],
+				se->inter,
+				se->inter_avg,
+				se->load_avg);
+		lh = lh->next;
+	}
+}
+
+static void rq_dump(struct htfs_rq *rq, int level)
+{
+	struct list_head *lh;
+	if (level > dbg_level)
+		return;
+	printk(KERN_EMERG "bw:%lu w:%lu run_cost:%lu\n",
+			rq->bweight,
+			(unsigned long)rq->bweight,
+			(unsigned long)rq->run_cost);
+	printk(KERN_EMERG "  sl:\n");
+	lh = &rq->spqs_real_weight;
+	while ((lh = lh->prev) != &rq->spqs_real_weight) {
+		struct htfs_pq *pq = list_entry(lh, struct htfs_pq, spqs_real_weight);
+		if (pq == rq->cur_pq) {
+			printk(KERN_EMERG "----vvvvv\n");
+		}
+		printk(KERN_EMERG "    real_bweight:%lu balance_ct:%lu\n",
+				(unsigned long)pq->real_bweight,
+				(unsigned long)pq->balance_ct);
+		pq_dump(pq, level);
+	}
+	printk(KERN_EMERG "\n");
+}
+
+static void rqs_dump(struct htfs_rqs *rqs, int level)
+{
+	if (level > dbg_level)
+		return;
+	printk(KERN_EMERG "rqs:%lu run:%lu vtime:%lu bct:%ld weight:%lu load:%lu load_avg:%lu load_contr:%lu slice_shift: %u\n",
+			(unsigned long)rqs, (unsigned long)rqs->nr_running,
+			(unsigned long)rqs->vtime,
+			(unsigned long)rqs->rq_balance_ct,
+			rqs->weight,
+			rqs->load,
+			rqs->load_avg,
+			rqs->load_contribution,
+			rqs->rq->slice_shift);
+	printk(KERN_EMERG "normalq ");
+	rq_dump(&rqs->normalq, level);
+	printk(KERN_EMERG "interq ");
+	rq_dump(&rqs->interq, level);
+	DBG_WAIT(1);
+}
+
+
+
+
+/******************************************************************************
+ * Function signatures and constant definitions
+ */
+static inline void pq_deactivate(struct htfs_rq *rq, struct htfs_pq *pq);
+static inline void pq_activate(struct htfs_rq *rq, struct htfs_pq *pq);
+static inline void
+pq_slist_resort_real_weight(struct htfs_rq *rq, struct htfs_pq *pq, int higher);
+
+
+
+
+// the static timeslice is used to decide boosted weight update, wakeup vruntime
+// updates, vtimestalls, and interq
+#define HTFS_STATIC_TIMESLICE_SHIFT 17
+// those defines are in number of shifts
+#define HTFS_TH_INTERQ 3
+#define HTFS_TH_BOOST 2
+#define HTFS_TH_WAKEUP 10
+
+#define HTFS_VTIME_ACCURACY 14
+
+//#define HTFS_LOAD_AVG 1
+#define HTFS_OLD_BALANCING 1
+
+#define calc_bweight_higher(weight) ((weight * weight_modifier[1]\
+	+ (1UL << (HTFS_WEIGHT_MOD_SHIFT - 1))) >> HTFS_WEIGHT_MOD_SHIFT)
+
+#define calc_bweight_lower(weight) ((weight * weight_modifier[0]\
+	+ (1UL << (HTFS_WEIGHT_MOD_SHIFT - 1))) >> HTFS_WEIGHT_MOD_SHIFT)
+
+
+/*
+ * The exponential sliding  window over which load is averaged for shares
+ * distribution.
+ * (default: 10msec)
+ */
+unsigned int __read_mostly sysctl_sched_shares_window = 10000000UL;
+
+unsigned int sysctl_sched_inter_slice_shift = 17;
+u64 sched_inter_slice = (1UL << 17);
+u64 sysctl_sched_inter_latency = 10000000ULL;
+
+unsigned int sysctl_sched_slice_max_shift = 30;
+
+
+int sched_proc_update_handler(struct ctl_table *table, int write,
+		void __user *buffer, size_t *lenp,
+		loff_t *ppos)
+{
+	int ret = proc_dointvec(table, write, buffer, lenp, ppos);
+	sched_inter_slice = (1UL << sysctl_sched_inter_slice_shift);
+
+	return ret;
+}
+
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+/* Walk up scheduling entities hierarchy */
+#define for_each_sched_entity(se) \
+		for (; se; se = se->parent)
+
+static inline struct htfs_rqs *group_htfs_rqs(struct sched_entity *se)
+{
+	return se->my_q;
+}
+
+#else
+#define for_each_sched_entity(se) \
+		for (; se; se = NULL)
+
+#endif
+
+static inline struct htfs_rqs *rqs_of_rq(struct htfs_rq *rq)
+{
+	return rq->rqs;
+}
+
+static inline struct htfs_rq *htfs_rq_of_se(struct sched_entity *se)
+{
+	return se->htfs_rq;
+}
+
+static inline struct htfs_rqs *rqs_of_se(struct sched_entity *se)
+{
+	return se->htfs_rqs;
+}
+
+static inline struct rq *rq_of_rqs(struct htfs_rqs *rqs)
+{
+	return rqs->rq;
+}
+
+static inline struct rq *rq_of_se(struct sched_entity *se)
+{
+	return rq_of_rqs(rqs_of_se(se));
+}
+
+/******************************************************************************
+ * operations about vtime and steppings
+ */
+
+static inline void rqs_update_vtime_concrete(struct htfs_rqs *rqs, u64 time)
+{
+	if (!rqs->inv_weight) {
+		rqs->inv_weight = calc_inv_weight(rqs->normalq.bweight);
+	}
+	rqs->vtime += (rqs->inv_weight * time)
+			>> (32 - HTFS_VTIME_ACCURACY);
+}
+
+/*
+ * updates the runqueues vtime
+ */
+static inline void rqs_update_vtime(struct htfs_rqs *rqs)
+{
+	if (!rqs->inv_weight) {
+		rqs->inv_weight = calc_inv_weight(rqs->normalq.bweight);
+	}
+	rqs->vtime += ((u64)rqs->inv_weight << rqs->rq->slice_shift)
+			>> (32 - HTFS_VTIME_ACCURACY);
+}
+
+/*
+ * updates the values of the runqueue rq if the new first pq in the real_weight
+ * list changed
+ */
+static inline void update_first_pq(struct htfs_rqs *rqs, struct htfs_rq *rq)
+{
+	struct htfs_pq *new_first = list_entry(rq->spqs_real_weight.prev,
+				struct htfs_pq, spqs_real_weight);
+	rq->run_cost = new_first->real_bweight;
+}
+
+/******************************************************************************
+ * se-operations
+ */
+static inline unsigned int se_find_bw_ind(struct sched_entity *se)
+{
+	int low = 0;
+	int up = HTFS_WEIGHT_LVLS;
+	int new;
+	const unsigned long w = se->load.weight;
+	while (low != up) {
+		new = ((up - low) >> 1) + low;
+		if (unlikely(w == bweights[new])) {
+			return new;
+		}
+		if (w < bweights[new]) {
+			low = new + 1;
+			if (unlikely(low >= HTFS_WEIGHT_LVLS))
+				return HTFS_WEIGHT_LVLS - 1;
+		} else {
+			up = new;
+			if (unlikely(up <= 0))
+				return 0;
+		}
+	}
+	return low;
+}
+
+static inline int se_is_on_interq(struct sched_entity *se)
+{
+	struct htfs_rqs *rqs = rqs_of_se(se);
+	return (&rqs->interq == htfs_rq_of_se(se));
+}
+
+#define HTFS_AVG_SHIFT 3
+#define HTFS_AVG_FACTOR ((1UL << HTFS_AVG_SHIFT) - 1)
+
+#if (defined CONFIG_SMP || !defined HTFS_OLD_BALANCING)
+
+static inline unsigned long calc_avg_after_sleep(u64 slice_shift, unsigned long avg,
+		u64 sleep_time)
+{
+	int i = sleep_time >> (slice_shift + 2);
+	if (i <= 0)
+		return avg;
+	avg >>= i;
+	return avg;
+}
+
+static inline void rqs_update_load_avg(struct htfs_rqs *rqs)
+{
+	unsigned long load_avg = (rqs->load_avg * HTFS_AVG_FACTOR + rqs->load
+			+ (1UL << (HTFS_AVG_SHIFT - 1)))
+			>> HTFS_AVG_SHIFT;
+#ifdef HTFS_LOAD_AVG
+	if (&rqs->rq->htfs_rqs == rqs) {
+		long diff = load_avg - rqs->load_avg;
+		if (diff < 0)
+			dec_cpu_load(rqs->rq, -diff);
+		else
+			inc_cpu_load(rqs->rq, diff);
+	}
+#endif
+	rqs->load_avg = load_avg;
+}
+
+static inline void rqs_wakeup_load_avg(struct htfs_rqs *rqs, struct rq *rq)
+{
+	u64 now = rq->clock;
+	u64 delta = now - rqs->offline_start;
+	unsigned long load_avg = calc_avg_after_sleep(HTFS_STATIC_TIMESLICE_SHIFT,
+			rqs->load_avg, delta);
+#ifdef HTFS_LOAD_AVG
+	if (&rqs->rq->htfs_rqs == rqs) {
+		long diff = load_avg - rqs->load_avg;
+		if (diff < 0)
+			dec_cpu_load(rqs->rq, -diff);
+		else
+			inc_cpu_load(rqs->rq, diff);
+	}
+#endif
+	rqs->load_avg = load_avg;
+}
+
+static inline void rqs_se_update_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		long load_diff);
+
+static inline void se_set_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		unsigned long new_load)
+{
+	rqs_se_update_load_avg(rqs_of_se(se), se, (long)(new_load - se->load_avg));
+	se->load_avg = new_load;
+}
+
+static inline void se_update_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		u64 unused_time)
+{
+#ifdef HTFS_LOAD_AVG
+	unsigned long new_load;
+	if (likely(unused_time == 0)) {
+		new_load = (se->load_avg * HTFS_AVG_FACTOR + se->load.weight)
+				>> HTFS_AVG_SHIFT;
+	} else {
+		if (rqs->rq->slice_granted <=
+				(1UL << sysctl_sched_inter_slice_shift)) {
+			new_load = (se->load_avg * HTFS_AVG_FACTOR
+				+ se->load.weight
+				- ((se->load.weight * unused_time)
+				>> sysctl_sched_inter_slice_shift))
+				>> HTFS_AVG_SHIFT;
+		} else if (rqs->rq->slice_granted <= rqs->rq->slice) {
+			new_load = (se->load_avg * HTFS_AVG_FACTOR
+				+ se->load.weight
+				- ((se->load.weight * unused_time)
+				>> rqs->rq->slice_shift))
+				>> HTFS_AVG_SHIFT;
+		} else {
+			new_load = se->load_avg;
+		}
+
+	}
+	se_set_load_avg(rqs, se, new_load);
+#endif
+}
+
+static inline void se_wakeup_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		u64 unused_time)
+{
+#ifdef HTFS_LOAD_AVG
+	if (unused_time == 0)
+		return;
+	se->load_avg = calc_avg_after_sleep(HTFS_STATIC_TIMESLICE_SHIFT,
+			se->load_avg, unused_time);
+#endif
+}
+
+#else /* CONFIG_SMP */
+
+static inline void rqs_update_load_avg(struct htfs_rqs *rqs)
+{
+}
+
+static inline void rqs_wakeup_load_avg(struct htfs_rqs *rqs, struct rq *rq)
+{
+}
+
+static inline void se_update_load_avg(struct htfs_rqs *rqs,struct sched_entity *se,
+		u64 unused_time)
+{
+}
+
+static inline void se_wakeup_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		u64 unused_time)
+{
+}
+
+#endif /* CONFIG_SMP */
+
+
+
+#define HTFS_INTER_MAX (1UL << 30)
+#define HTFS_INTER_MIN (0L)
+
+/*
+ * this interactive value is currently not used... but they are going to be used
+
+#ifdef CONFIG_SMP
+static void se_inter_inc(struct sched_entity *se, unsigned long delta)
+{
+	se->inter = min(HTFS_INTER_MAX, se->inter + delta);
+}
+
+static void se_inter_dec(struct sched_entity *se, unsigned long delta)
+{
+	se->inter = (unsigned long) max(HTFS_INTER_MIN, (long)(se->inter - delta));
+}
+
+static void se_update_rqs_inter_avg(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	unsigned long new_avg = (se->inter_avg * 3 + se->inter) >> 2;
+	rqs->inter = rqs->inter - se->inter_avg + new_avg;
+	se->inter_avg = new_avg;
+}
+
+static void se_update_inter_avg_punish(struct htfs_rqs *rqs,
+		struct sched_entity *se)
+{
+	se_inter_inc(se, se->load.weight);
+	se_update_rqs_inter_avg(rqs, se);
+}
+
+static void se_update_inter_avg(struct htfs_rqs *rqs,
+		struct sched_entity *se)
+{
+	se_inter_dec(se, se->load.weight);
+	se_update_rqs_inter_avg(rqs, se);
+}
+
+static void se_update_inter_dequeue(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	se_inter_inc(se, se->load.weight);
+	rqs->inter -= se->inter_avg;
+}
+
+static void se_update_inter_wakeup(struct htfs_rqs *rqs, struct sched_entity *se,
+		u64 sleep_time)
+{
+	u64 weighted_sleep = (sleep_time >> HTFS_STATIC_TIMESLICE_SHIFT)
+			* se->load.weight;
+	if (weighted_sleep > se->inter) {
+		se->inter = HTFS_INTER_MIN;
+		se->inter_avg = HTFS_INTER_MIN;
+	} else {
+		se_inter_dec(se, weighted_sleep);
+		se->inter_avg = max(HTFS_INTER_MIN,
+				(long)(se->inter_avg - weighted_sleep));
+	}
+	se_inter_inc(se, 2 * se->load.weight);
+	rqs->inter += se->inter_avg;
+}
+
+static void se_inter_init(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	se->inter = HTFS_INTER_MIN + 2 * se->load.weight;
+	se->inter_avg = HTFS_INTER_MIN + 2 * se->load.weight;
+}
+
+#else
+*/
+static inline void se_update_inter_avg_punish(struct htfs_rqs *rqs,
+		struct sched_entity *se)
+{
+}
+
+static inline void se_update_inter_avg(struct htfs_rqs *rqs,
+		struct sched_entity *se)
+{
+}
+
+static inline void se_update_inter_dequeue(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+}
+
+static inline void se_update_inter_wakeup(struct htfs_rqs *rqs, struct sched_entity *se,
+		u64 sleep_time)
+{
+
+}
+
+static inline void se_inter_init(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+
+}
+
+//#endif
+
+/*
+ * Set the vruntime after wakeup of se. The vruntime has to be higher than
+ * vtime - 2^HTFS_TH_WAKEUP * timeslice.
+ * 
+ */
+static inline void se_wakeup_set_vruntime(struct htfs_rqs *rqs,
+		struct sched_entity *se)
+{
+	u64 new_vruntime;
+	u64 thresh_vruntime = ((u64)se->load.inv_weight
+			<< HTFS_STATIC_TIMESLICE_SHIFT)
+			>> (32 - HTFS_TH_WAKEUP - HTFS_VTIME_ACCURACY);
+	if (se->vruntime > rqs->vtime) {
+		if (unlikely(se->vruntime - rqs->vtime > thresh_vruntime))
+			new_vruntime = rqs->vtime + thresh_vruntime;
+		else
+			new_vruntime = se->vruntime;
+	} else {
+		if (unlikely(rqs->vtime - se->vruntime > thresh_vruntime)) {
+			u64 vtime_diff;
+			u64 sleep_time;
+			new_vruntime = rqs->vtime - thresh_vruntime;
+			vtime_diff = new_vruntime - se->vruntime;
+			sleep_time = vtime_diff / se->load.inv_weight;
+			se_update_inter_wakeup(rqs, se, sleep_time);
+			se_wakeup_load_avg(rqs, se, sleep_time);
+		} else {
+			new_vruntime = se->vruntime;
+		}
+	}
+	se->vruntime = new_vruntime;
+}
+
+#define HTFS_SLICE_DEVIATION (1UL << 14)
+
+/*
+ * If the se did not use the full timeslice available, punish it by adding
+ * one eighth of the possible timeslice to the vruntime
+ */
+#define HTFS_NOT_FULL_SLICE 3
+
+/*
+ * update vruntime after runnig
+ */
+static inline void se_update_vruntime(struct sched_entity *se)
+{
+	struct htfs_rqs *rqs = rqs_of_se(se);
+	struct rq *rq = rqs->rq;
+	u64 ran = se->sum_exec_runtime - se->prev_sum_exec_runtime;
+	u64 vran = (ran * se->load.inv_weight) >> (32 - HTFS_VTIME_ACCURACY);
+	s64 slice_deviation = rq->slice_granted - ran;
+	rq->slice_remain = max(rq->slice_remain, ran) - ran;
+	se->vruntime += vran;
+	if (unlikely(se->htfs_state & HTFS_PREEMPTED)) {
+		se->htfs_state &= ~HTFS_PREEMPTED;
+		if (!se_is_on_interq(se))
+			rqs_update_vtime_concrete(rqs, ran);
+		goto full_slice_usage;
+	}
+	if (!se_is_on_interq(se))
+		rqs_update_vtime_concrete(rqs, rq->slice_granted);
+
+	// Punishing the tasks that leave the cpu much too early...
+	if (abs(slice_deviation) > HTFS_SLICE_DEVIATION) {
+		if ((s64)(rqs->rq->slice_granted - ran)
+				< rqs->rq->slice_granted >> HTFS_NOT_FULL_SLICE) {
+			goto full_slice_usage;
+		}
+		se->vruntime += ((rqs->rq->slice_granted >> HTFS_NOT_FULL_SLICE)
+				* se->load.inv_weight)
+				>> (32 - HTFS_VTIME_ACCURACY);
+		se_update_inter_avg_punish(rqs, se);
+		se_update_load_avg(rqs, se,
+				rqs->rq->slice_granted >> HTFS_NOT_FULL_SLICE);
+	} else {
+full_slice_usage:
+		se_update_inter_avg(rqs, se);
+		se_update_load_avg(rqs, se, 0);
+	}
+
+	se->prev_sum_exec_runtime = se->sum_exec_runtime;
+}
+
+/*
+ * set the se exec_start to now
+ */
+static inline void se_start_exec(struct sched_entity *se, struct rq *rq)
+{
+	unsigned long now = rq->clock_task;
+	se->exec_start = now;
+}
+
+/*
+ * update the real runtime of the process and return the remaining time in this
+ * slice
+ */
+static inline s64 se_update_runtime(struct sched_entity *se, struct rq *rq)
+{
+	u64 now = rq->clock_task;
+	struct htfs_rqs *rqs = rqs_of_se(se);
+	s64 remaining;
+	se->sum_exec_runtime += now - se->exec_start;
+	se->exec_start = now;
+	remaining = rqs->rq->slice_granted
+			- (s64)(se->sum_exec_runtime - se->prev_sum_exec_runtime);
+	return remaining;
+}
+
+enum se_need_newpq
+{
+	SE_ENQUEUE_NEW,
+	SE_REENQUEUE_LAST
+};
+
+/*
+ * calculates the new weight of a se and stores it at new_weight. Returns if the
+ * se can be enqueued on the last priorityqueue or it has to be enqueued on a
+ * priorityqueue with higher or lower weight.
+ */
+static inline enum se_need_newpq rq_se_get_new_bw_ind(struct htfs_rqs *rqs,
+		struct htfs_rq *rq, struct sched_entity *se,
+		unsigned int *new_bw_ind)
+{
+	s64 vdiff = (s64)(se->vruntime - rqs->vtime);
+
+//	int badness = (abs(vdiff) << HTFS_VTIME_ACCURACY)
+//				>> (rqs->rq->slice_shift + HTFS_TH_BOOST);
+//	u64 vran = (ran * se->load.inv_weight) >> (32 - HTFS_VTIME_ACCURACY);
+//	int badness = (( (u64)abs(vdiff) << (32 - HTFS_VTIME_ACCURACY)) * se->load.weight)
+//			>> (32 + rqs->rq->slice_shift + HTFS_TH_BOOST);
+	int badness = ((u64)abs(vdiff) * se->load.weight)
+			>> (HTFS_VTIME_ACCURACY + rqs->rq->slice_shift + HTFS_TH_BOOST);
+	if (unlikely(badness)) {
+		if (vdiff < 0) {
+			if (unlikely(se->last_vdiff > vdiff)) {
+				if (likely(se->bw_ind != 0)) {
+					*new_bw_ind = se->bw_ind - 1;
+					goto new_weight;
+				}
+				se->htfs_state |= HTFS_NEED_INTERQ;
+			}
+		} else {
+			if (unlikely(se->last_vdiff < vdiff
+					&& se->bw_ind < HTFS_WEIGHT_LVLS - 1)) {
+				*new_bw_ind = se->bw_ind + 1;
+				goto new_weight;
+			}
+		}
+	}
+	*new_bw_ind = se->bw_ind;
+	se->last_vdiff = vdiff;
+	return SE_REENQUEUE_LAST;
+
+new_weight:
+	se->last_vdiff = vdiff;
+	return SE_ENQUEUE_NEW;
+
+}
+
+/******************************************************************************
+ * pq-operations
+ */
+
+/*
+ * Enqueue se on the pq
+ */
+static inline void pq_enqueue(struct htfs_pq *pq, struct sched_entity *se)
+{
+	list_add_tail(&se->htfs_pq_item, &pq->queue);
+}
+
+/*
+ * Dequeue se from the pq
+ */
+static inline void pq_dequeue(struct htfs_pq *pq, struct sched_entity *se)
+{
+	list_del(&se->htfs_pq_item);
+}
+
+/*
+ * Get the next se from this pq. This does not dequeue the se. Dequeuing is done
+ * when removing the task, or put the task back on the queue
+ */
+static inline struct sched_entity *pq_dequeue_next(struct htfs_pq *pq)
+{
+	struct sched_entity *se = list_entry(pq->queue.next,
+			struct sched_entity, htfs_pq_item);
+	return se;
+}
+
+/*
+ * Delete the se from the pq. Including weight updates
+ */
+static inline void pq_del(struct htfs_rq *rq, struct htfs_pq *pq,
+		struct sched_entity *se)
+{
+	pq_dequeue(pq, se);
+	pq->real_bweight -= bweights[se->bw_ind];
+	if (unlikely(pq->real_bweight == 0)) {
+		pq_deactivate(rq, pq);
+	} else {
+		pq_slist_resort_real_weight(rq, pq, 0);
+	}
+}
+
+/*
+ * Add a new se to this pq. This does only the weight changes and so on.
+ * se is not enqueued.
+ */
+static inline void pq_add(struct htfs_rq *rq, struct htfs_pq *pq,
+		struct sched_entity *se)
+{
+	if (unlikely(pq->real_bweight == 0)) {
+		pq_activate(rq, pq);
+	}
+	pq->real_bweight += bweights[se->bw_ind];
+	pq_slist_resort_real_weight(rq, pq, 1);
+}
+
+
+
+
+
+
+/******************************************************************************
+ * priorityqueue management in a runqueue
+ */
+
+/*
+ * resorts a pq into the right place, starting at the current pq's
+ * position
+ */
+//TODO: the direction to compare to is given.
+#define spqs_resort(rq, pq, itemname, pqvaluename, higher) \
+{\
+	struct list_head *lh = &pq->itemname;\
+	const unsigned long cur_val = pq->pqvaluename;\
+	struct list_head *lh_cur;\
+	struct list_head *end = &rq->itemname;\
+	struct htfs_pq *pq_cur;\
+	if (higher) {\
+		lh_cur = lh->next;\
+		pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+		if (lh_cur != end && cur_val > pq_cur->pqvaluename) {\
+			list_del(lh);\
+			lh_cur = lh_cur->next;\
+			pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+			while (lh_cur != end && cur_val > pq_cur->pqvaluename) {\
+				lh_cur = lh_cur->next;\
+				pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+			}\
+			list_add_tail(lh, lh_cur);\
+			return;\
+		}\
+	} else {\
+		lh_cur = lh->prev;\
+		pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+		if (lh_cur != end && cur_val < pq_cur->pqvaluename) {\
+			list_del(lh);\
+			lh_cur = lh_cur->prev;\
+			pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+			while (lh_cur != end && cur_val > pq_cur->pqvaluename) {\
+				lh_cur = lh_cur->prev;\
+				pq_cur = list_entry(lh_cur, struct htfs_pq, itemname);\
+			}\
+			list_add(lh, lh_cur);\
+		}\
+	}\
+}
+
+/**
+ * resorts the element (pq) in the sorted list of priorityqueues
+ */
+static inline void
+pq_slist_resort_real_weight(struct htfs_rq *rq, struct htfs_pq *pq, int higher)
+{
+	struct htfs_rqs *rqs = rqs_of_rq(rq);
+	int update_first = (rq->spqs_real_weight.prev == &pq->spqs_real_weight);
+	spqs_resort(rq, pq, spqs_real_weight, real_bweight, higher);
+	if (update_first || rq->spqs_real_weight.prev == &pq->spqs_real_weight) {
+		update_first_pq(rqs, rq);
+	}
+}
+
+static inline void pq_balance_inc(struct htfs_pq *pq)
+{
+	pq->balance_ct += pq->real_bweight;
+}
+
+/*
+ * deactivate a empty priorityqueue
+ */
+static inline void pq_deactivate(struct htfs_rq *rq, struct htfs_pq *pq)
+{
+	// if this is the cur_pq, we need to replace it by a the best next
+	// priorityqueue
+	if (unlikely(rq->cur_pq == pq)) {
+		if (pq->spqs_real_weight.prev == &rq->spqs_real_weight) {
+			if (pq->spqs_real_weight.next == &rq->spqs_real_weight) {
+				rq->cur_pq = NULL;
+			} else {
+				rq->cur_pq = list_entry(pq->spqs_real_weight.next,
+						struct htfs_pq, spqs_real_weight);
+			}
+		} else {
+			rq->cur_pq = list_entry(pq->spqs_real_weight.prev,
+					struct htfs_pq, spqs_real_weight);
+			pq_balance_inc(rq->cur_pq);
+		}
+	}
+	// in case this was the priorityqueue with the lowest real_bweight
+	// we need to update the real_weight list
+	if (&pq->spqs_real_weight == rq->spqs_real_weight.prev) {
+		list_del(&pq->spqs_real_weight);
+		if (likely(rq->spqs_real_weight.prev != &rq->spqs_real_weight)) {
+			update_first_pq(rqs_of_rq(rq), rq);
+		}
+	} else {
+		list_del(&pq->spqs_real_weight);
+	}
+}
+
+static inline void pq_activate(struct htfs_rq *rq, struct htfs_pq *pq)
+{
+	pq->balance_ct = 0;
+	list_add(&pq->spqs_real_weight, &rq->spqs_real_weight);
+	if (unlikely(rq->cur_pq == NULL)) {
+		rq->cur_pq = pq;
+	}
+}
+
+/******************************************************************************
+ * rq-operations
+ */
+
+static inline void rqs_update_balance_ct_inter(struct htfs_rqs *rqs);
+static inline void rqs_update_balance_ct_normal(struct htfs_rqs *rqs);
+
+/*
+ * update weight rq. Only use this with weight updates...
+ * do not use on add or remove operations.
+ */
+static inline void rq_update_weight(struct htfs_rq *rq, s64 diff)
+{
+	rq->bweight += diff;
+	if (&rq->rqs->normalq == rq)
+		rq->rqs->inv_weight = 0;
+}
+
+/*
+ * decreasing weight, used when removing an entity
+ */
+static inline void rq_dec_bweight(struct htfs_rq *rq, u64 decweight)
+{
+	rq->bweight -= decweight;
+	if (unlikely(rq->bweight == 0)) {
+		struct htfs_rqs *rqs = rqs_of_rq(rq);
+		if (&rqs->interq == rq)
+			rqs->rq_balance_ct = -1;
+		else
+			rqs->rq_balance_ct = 1;
+	}
+	if (&rq->rqs->normalq == rq)
+		rq->rqs->inv_weight = 0;
+}
+
+/*
+ * increasing weight, used when adding an entity
+ */
+static inline void rq_inc_bweight(struct htfs_rq *rq, u64 incweight)
+{
+	if (unlikely(rq->bweight == 0)) {
+		struct htfs_rqs *rqs = rqs_of_rq(rq);
+		/*
+		 * the interactive runqueue has to be priorised to give the
+		 * interactive tasks enough slices.
+		 */
+		if (&rqs->interq == rq) {
+			rqs->rq_balance_ct = 1;
+			rqs_update_balance_ct_normal(rqs);
+		} else {
+			rqs->rq_balance_ct = -1;
+		}
+	}
+	if (&rq->rqs->normalq == rq)
+		rq->rqs->inv_weight = 0;
+	rq->bweight += incweight;
+}
+
+/*
+ * set the boosted weight while the se is not on a priorityqueue
+ */
+static inline s64 rq_se_set_bw_ind(struct htfs_rq *rq,
+		struct sched_entity *se, unsigned int bw_ind)
+{
+	s64 result = bweights[bw_ind] - bweights[se->bw_ind];
+	rq_update_weight(rq, result);
+	se->bw_ind = bw_ind;
+	return result;
+}
+
+/*
+ * delete the entity from the runqueue
+ */
+static inline void rq_del(struct htfs_rq *rq, struct sched_entity *se)
+{
+	pq_del(rq, &rq->pqs[se->bw_ind], se);
+	rq_dec_bweight(rq, bweights[se->bw_ind]);
+}
+
+/**
+ * adding the se to this rq. this only adds values
+ */
+static inline void rq_add(struct htfs_rq *rq, struct sched_entity *se)
+{
+	rq_inc_bweight(rq, bweights[se->bw_ind]);
+	se->htfs_rq = rq;
+}
+
+/*
+ * enqueue an entity to this runqueue
+ */
+static inline void rq_enqueue(struct htfs_rqs *rqs, struct htfs_rq *rq,
+		struct sched_entity *se)
+{
+	struct htfs_pq *pq;
+	unsigned int new_bw_ind = 0;
+	if (SE_ENQUEUE_NEW == rq_se_get_new_bw_ind(rqs, rq, se, &new_bw_ind))
+		rq_se_set_bw_ind(rq, se, new_bw_ind);
+	pq = &rq->pqs[se->bw_ind];
+	pq_add(rq, pq, se);
+	pq_enqueue(pq, se);
+}
+
+/*
+ * reenqueue an entity to this runqueue. This also takes care of calculating a
+ * new weight
+ */
+static inline void rq_reenqueue(struct htfs_rqs *rqs, struct htfs_rq *rq,
+		struct sched_entity *se)
+{
+	struct htfs_pq *last_pq = &rq->pqs[se->bw_ind];
+	unsigned int new_bw_ind = 0;
+	struct htfs_pq *pq = NULL;
+	enum se_need_newpq status = rq_se_get_new_bw_ind(rqs, rq, se,
+			&new_bw_ind);
+	if (likely(status == SE_REENQUEUE_LAST)) {
+		pq_dequeue(last_pq, se);
+		pq_enqueue(last_pq, se);
+	} else {
+		pq_del(rq, last_pq, se);
+		rq_se_set_bw_ind(rq, se, new_bw_ind);
+		pq = &rq->pqs[se->bw_ind];
+		pq_add(rq, pq, se);
+		pq_enqueue(pq, se);
+	}
+}
+
+/*
+ * dequeue the next entity to schedule
+ *
+ * The function goes through all priorityqueues and looks for a share_ct >= 0.
+ * In this case the next task from that priorityqueue is scheduled
+ */
+static inline struct sched_entity *rq_dequeue_next(struct htfs_rqs *rqs,
+		struct htfs_rq *rq)
+{
+	struct htfs_pq *cur_pq = rq->cur_pq;
+	struct list_head *possible_next = &cur_pq->spqs_real_weight;
+	const unsigned long run_cost = rq->run_cost;
+	const struct list_head *end = &rq->spqs_real_weight;
+	while (cur_pq->balance_ct < run_cost) {
+		possible_next = possible_next->prev;
+		if (unlikely(possible_next == end)) {
+			possible_next = possible_next->prev;
+			cur_pq = list_entry(possible_next, struct htfs_pq,
+					spqs_real_weight);
+			goto dequeue;
+		}
+		cur_pq = list_entry(possible_next, struct htfs_pq,
+				spqs_real_weight);
+		pq_balance_inc(cur_pq);
+	}
+	cur_pq->balance_ct -= rq->run_cost;
+dequeue:
+	rq->cur_pq = cur_pq;
+	return pq_dequeue_next(cur_pq);
+}
+
+
+/******************************************************************************
+ * rqs-operations
+ */
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+
+#define for_each_leaf_htfs_rqs(rq, rqs) \
+	list_for_each_entry_rcu(rqs, &rq->leaf_htfs_rqs_list, leaf_htfs_rqs_list)
+
+static inline void list_add_leaf_htfs_rqs(struct htfs_rqs *rqs)
+{
+	struct task_group *tg = rqs->tg->parent;
+	if (tg) {
+		struct htfs_rqs *parent_rqs = tg->htfs_rqs[cpu_of(rq_of_rqs(rqs))];
+		if (parent_rqs->tasks.next != &parent_rqs->tasks) {
+			list_add_rcu(&rqs->leaf_htfs_rqs_list,
+					&rq_of_rqs(rqs)->leaf_htfs_rqs_list);
+			return;
+		}
+	}
+	list_add_tail_rcu(&rqs->leaf_htfs_rqs_list,
+			&rq_of_rqs(rqs)->leaf_htfs_rqs_list);
+}
+
+static inline void list_del_leaf_htfs_rqs(struct htfs_rqs *rqs)
+{
+	list_del_rcu(&rqs->leaf_htfs_rqs_list);
+}
+
+static inline void rqs_add_if_real(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	if (!entity_is_task(se))
+		return;
+	if (rqs->tasks.next == &rqs->tasks)
+		list_add_leaf_htfs_rqs(rqs);
+	// add_tail to group interactive tasks at the end of the list...
+	// this should increase the probability to choose stable running tasks
+	// for balancing...
+	list_add_tail(&se->group_node, &rqs->tasks);
+}
+
+static inline void rqs_del_if_real(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	if (!entity_is_task(se))
+		return;
+	list_del(&se->group_node);
+	if (rqs->tasks.next == &rqs->tasks)
+		list_del_leaf_htfs_rqs(rqs);
+}
+
+#else /* CONFIG_FAIR_GROUP_SCHED */
+
+static inline void list_add_leaf_htfs_rqs(struct htfs_rqs *rqs)
+{
+}
+
+static inline void list_del_leaf_htfs_rqs(struct htfs_rqs *rqs)
+{
+}
+
+static inline void rqs_add_if_real(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+}
+
+static inline void rqs_del_if_real(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+}
+#endif /* CONFIG_FAIR_GROUP_SCHED */
+
+static inline unsigned int
+should_interq(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	if (likely((s64)(se->vruntime - rqs->vtime) <
+			(s64)(se->load.inv_weight << HTFS_STATIC_TIMESLICE_SHIFT)
+			>> (32 - HTFS_VTIME_ACCURACY - HTFS_TH_INTERQ)))
+		return 1;
+	return 0;
+}
+
+/**
+ * Used to enqueue tasks after running on the CPU
+ */
+static inline void rqs_reenqueue(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	struct htfs_rq *rq = htfs_rq_of_se(se);
+	se_update_vruntime(se);
+	if (!se->on_rq)
+		return;
+	if (rq == &rqs->interq) {
+		if (should_interq(rqs, se)) {
+			se->wakeup_time = rqs->rq->clock;
+			rq_reenqueue(rqs, rq, se);
+		} else {
+			se->htfs_state &= ~HTFS_NEED_INTERQ;
+			rq_del(rq, se);
+			rq = &rqs->normalq;
+			rq_add(rq, se);
+			rq_enqueue(rqs, rq, se);
+		}
+	} else {
+		if (unlikely(se->htfs_state & HTFS_NEED_INTERQ)) {
+			se->wakeup_time = rqs->rq->clock;
+			rq_del(rq, se);
+			rq = &rqs->interq;
+			rq_add(rq, se);
+			rq_enqueue(rqs, rq, se);
+		} else {
+			rq_reenqueue(rqs, rq, se);
+		}
+	}
+}
+
+static inline void update_htfs_load_contribution(struct htfs_rqs *rqs,
+					    int global_update);
+static inline void update_htfs_shares(struct htfs_rqs *rqs);
+
+static inline void rqs_add_se_weights(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+#ifdef HTFS_LOAD_AVG
+	rqs->load += se->load_avg;
+#else
+	if (!parent_entity(se))
+		inc_cpu_load(rq_of_rqs(rqs), se->load.weight);
+	rqs->load += se->load.weight;
+#endif
+	rqs->weight += se->load.weight;
+	update_htfs_load_contribution(rqs, 0);
+	update_htfs_shares(rqs);
+}
+
+static inline void rqs_del_se_weights(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+#ifdef HTFS_LOAD_AVG
+	rqs->load -= se->load_avg;
+#else
+	if (!parent_entity(se))
+		dec_cpu_load(rq_of_rqs(rqs), se->load.weight);
+	rqs->load -= se->load.weight;
+#endif
+	rqs->weight -= se->load.weight;
+	update_htfs_load_contribution(rqs, 0);
+	update_htfs_shares(rqs);
+}
+
+static inline void rqs_se_update_weight(struct htfs_rqs *rqs, long weight_diff)
+{
+	rqs->weight += weight_diff;
+}
+
+static inline void rqs_se_update_load_avg(struct htfs_rqs *rqs, struct sched_entity *se,
+		long load_diff)
+{
+#ifdef HTFS_LOAD_AVG
+	rqs->load += load_diff;
+#endif
+}
+
+#ifdef HTFS_OLD_BALANCING
+static void update_htfs_load(struct htfs_rqs *rqs, int global_update);
+#endif
+
+/*
+ * add an entity to the htfs_rqs
+ */
+static inline void
+rqs_add(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	if (unlikely(++rqs->nr_running == 1))
+		rqs_wakeup_load_avg(rqs, rq_of_se(se));
+	rqs_add_se_weights(rqs, se);
+	rqs_add_if_real(rqs, se);
+#ifdef HTFS_OLD_BALANCING
+	update_htfs_load(rqs, 0);
+	update_htfs_shares(rqs);
+#endif
+	if (likely(should_interq(rqs, se))) {
+		se->wakeup_time = rqs->rq->clock;
+		rq_add(&rqs->interq, se);
+		rq_enqueue(rqs, &rqs->interq, se);
+	} else {
+		rq_add(&rqs->normalq, se);
+		rq_enqueue(rqs, &rqs->normalq, se);
+	}
+	se->on_rq = 1;
+}
+
+/*
+ * Remove an entity from the htfs_rqs
+ */
+static inline void
+rqs_del(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	struct htfs_rq *rq = htfs_rq_of_se(se);
+	se_update_runtime(se, rq_of_rqs(rqs));
+	se_update_inter_dequeue(rqs, se);
+	se_update_vruntime(se);
+	se_update_inter_dequeue(rqs, se);
+	if (unlikely(--rqs->nr_running == 0))
+		rqs->offline_start = rq_of_se(se)->clock;
+	rqs_del_se_weights(rqs, se);
+	rq_del(rq, se);
+	se->on_rq = 0;
+	rqs_del_if_real(rqs, se);
+#ifdef HTFS_OLD_BALANCING
+	update_htfs_load(rqs, 0);
+	update_htfs_shares(rqs);
+#endif
+}
+
+
+static inline void rq_run_inter_se(struct rq *rq, struct sched_entity *se)
+{
+	if (!entity_is_task(se))
+		return;
+	if (rq->clock - se->wakeup_time > sysctl_sched_inter_latency)
+		++rq->slice_shrink;
+}
+
+static inline void rqs_update_balance_ct_normal(struct htfs_rqs *rqs)
+{
+	rqs->rq_balance_ct += rqs->interq.bweight
+		<< (rqs->rq->slice_shift - sysctl_sched_inter_slice_shift + 4);
+}
+
+static inline void rqs_update_balance_ct_inter(struct htfs_rqs *rqs)
+{
+	rqs->rq_balance_ct -= rqs->normalq.bweight;
+}
+
+static inline struct sched_entity *rqs_pick_next_full_slice(
+		struct rq *rq, struct htfs_rqs *rqs, int *inter_entity)
+{
+	// TODO on rq add/del update the counter...
+	// TODO more sophisticated interactive queue handling
+	struct sched_entity *se;
+	//if (rqs->rq_balance_ct < 0) { // normal runqueue
+	if (rqs->interq.bweight == 0) {
+		rqs_update_balance_ct_normal(rqs);
+		se = rq_dequeue_next(rqs, &rqs->normalq);
+	} else { // interactive runqueue
+		rqs_update_balance_ct_inter(rqs);
+		se = rq_dequeue_next(rqs, &rqs->interq);
+		rq_run_inter_se(rq, se);
+		*inter_entity = 1;
+	}
+	return se;
+}
+
+static inline struct sched_entity *rqs_pick_next_inter_slice(
+		struct rq *rq, struct htfs_rqs *rqs, int *inter_entity)
+{
+	struct sched_entity *se;
+	if (rqs->interq.bweight != 0) {
+		rqs_update_balance_ct_inter(rqs);
+		se = rq_dequeue_next(rqs, &rqs->interq);
+		rq_run_inter_se(rq, se);
+		*inter_entity = 1;
+	} else {
+		rqs_update_balance_ct_normal(rqs);
+		se = rq_dequeue_next(rqs, &rqs->normalq);
+	}
+	return se;
+}
+
+static inline int rqs_se_move_interq(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	if (should_interq(rqs, se)) {
+		struct htfs_rq *rq = htfs_rq_of_se(se);
+		rq_del(rq, se);
+		rq = &rqs->interq;
+		rq_add(rq, se);
+		rq_enqueue(rqs, rq, se);
+		return 1;
+	}
+	return 0;
+}
+
+static inline int rqs_se_move_normalq(struct htfs_rqs *rqs, struct sched_entity *se)
+{
+	struct htfs_rq *rq = htfs_rq_of_se(se);
+	rq_del(rq, se);
+	rq = &rqs->normalq;
+	rq_add(rq, se);
+	rq_enqueue(rqs, rq, se);
+	return 1;
+}
+
+/******************************************************************************
+ * taskgroup operations
+ */
+
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+#ifdef CONFIG_SMP
+
+#ifdef HTFS_OLD_BALANCING
+
+static void update_htfs_load_contribution(struct htfs_rqs *rqs,
+					    int global_update)
+{
+	struct task_group *tg = rqs->tg;
+	long load_avg;
+
+	load_avg = div64_u64(rqs->load_avg, rqs->load_period+1);
+	load_avg -= rqs->load_contribution;
+
+	if (global_update || abs(load_avg) > rqs->load_contribution / 8) {
+		atomic_add(load_avg, &tg->load_weight);
+		rqs->load_contribution += load_avg;
+	}
+}
+
+static void update_htfs_load(struct htfs_rqs *rqs, int global_update)
+{
+	u64 period = sysctl_sched_shares_window;
+	u64 now, delta;
+	unsigned long load = rqs->load;
+
+	if (rqs->tg == &root_task_group)
+		return;
+
+	now = rq_of_rqs(rqs)->clock_task;
+	delta = now - rqs->load_stamp;
+
+	/* truncate load history at 4 idle periods */
+	if (rqs->load_stamp > rqs->load_last &&
+	    now - rqs->load_last > 4 * period) {
+		rqs->load_period = 0;
+		rqs->load_avg = 0;
+	}
+
+	rqs->load_stamp = now;
+	rqs->load_unacc_exec_time = 0;
+	rqs->load_period += delta;
+	if (load) {
+		rqs->load_last = now;
+		rqs->load_avg += delta * load;
+	}
+
+	/* consider updating load contribution on each fold or truncate */
+	if (global_update || rqs->load_period > period
+	    || !rqs->load_period)
+		update_htfs_load_contribution(rqs, global_update);
+
+	while (rqs->load_period > period) {
+		/*
+		 * Inline assembly required to prevent the compiler
+		 * optimising this loop into a divmod call.
+		 * See __iter_div_u64_rem() for another example of this.
+		 */
+		asm("" : "+rm" (rqs->load_period));
+		rqs->load_period /= 2;
+		rqs->load_avg /= 2;
+	}
+}
+
+static long calc_htfs_shares(struct htfs_rqs *rqs, struct task_group *tg)
+{
+	long load_weight, load, shares;
+
+	load = rqs->load;
+
+	load_weight = atomic_read(&tg->load_weight);
+	load_weight -= rqs->load_contribution;
+	load_weight += load;
+
+	shares = (tg->shares * load);
+	if (load_weight)
+		shares /= load_weight;
+
+	if (shares < MIN_SHARES)
+		shares = MIN_SHARES;
+	if (shares > tg->shares)
+		shares = tg->shares;
+
+	return shares;
+}
+
+static void update_entity_shares_tick(struct htfs_rqs *rqs)
+{
+	if (rqs->load_unacc_exec_time > sysctl_sched_shares_window) {
+		update_htfs_load(rqs, 0);
+		update_htfs_shares(rqs);
+	}
+}
+
+#else
+static inline void update_htfs_load_contribution(struct htfs_rqs *rqs,
+					    int global_update)
+{
+	struct task_group *tg = rqs->tg;
+	long load_avg;
+
+	load_avg = rqs->load_avg;
+	load_avg -= rqs->load_contribution;
+
+	if (global_update || abs(load_avg) > rqs->load_contribution / 8) {
+		atomic_add(load_avg, &tg->load_weight);
+		rqs->load_contribution += load_avg;
+	}
+}
+
+// FIXME is weight_delta somewher != 0?
+static inline long calc_htfs_shares(struct htfs_rqs *rqs, struct task_group *tg)
+{
+	long load_weight, load, shares;
+
+	load = rqs->weight;
+
+	load_weight = atomic_read(&tg->load_weight);
+	load_weight -= rqs->load_contribution;
+	load_weight += load;
+
+	shares = (tg->shares * load);
+	if (load_weight)
+		shares /= load_weight;
+
+	if (shares < MIN_SHARES)
+		shares = MIN_SHARES;
+	if (shares > tg->shares)
+		shares = tg->shares;
+
+	return shares;
+}
+static void update_entity_shares_tick(struct htfs_rqs *rqs)
+{
+
+}
+#endif
+
+# else /* CONFIG_SMP */
+
+static inline long calc_htfs_shares(struct htfs_rqs *rqs, struct task_group *tg)
+{
+	return tg->shares;
+}
+static void update_entity_shares_tick(struct cfs_rq *cfs_rq)
+{
+}
+
+# endif /* CONFIG_SMP */
+static inline void reweight_entity(struct htfs_rqs *rqs, struct sched_entity *se,
+			    unsigned long weight)
+{
+	if (se->on_rq) {
+		// everything is based on bweight... so the bweight will be modified
+		// on next reenqueue
+		rqs_se_update_weight(rqs, weight - se->load.weight);
+	}
+	update_load_set(&se->load, weight);
+}
+
+static inline void update_htfs_shares(struct htfs_rqs *rqs)
+{
+	struct task_group *tg;
+	struct sched_entity *se;
+	long shares;
+
+	tg = rqs->tg;
+	se = tg->se[cpu_of(rq_of_rqs(rqs))];
+	if (!se)
+		return;
+#ifndef CONFIG_SMP
+	if (likely(se->load.weight == tg->shares))
+		return;
+#endif
+	shares = calc_htfs_shares(rqs, tg);
+
+	reweight_entity(rqs_of_se(se), se, shares);
+}
+#else /* CONFIG_FAIR_GROUP_SCHED */
+
+static inline void update_htfs_shares(struct htfs_rqs *rqs)
+{
+}
+
+#endif /* CONFIG_FAIR_GROUP_SCHED */
+
+
+/******************************************************************************
+ * SMP operations not in the interface. Used by code in sched_fair.c
+ */
+
+#ifdef CONFIG_SMP
+
+/*
+ * pull_task - move a task from a remote runqueue to the local runqueue.
+ * Both runqueues must be locked.
+ */
+static inline void pull_task(struct rq *src_rq, struct task_struct *p,
+		      struct rq *this_rq, int this_cpu)
+{
+	// TODO: update hierarchy to reflect the vruntime state of the task
+	deactivate_task(src_rq, p, 0);
+	set_task_cpu(p, this_cpu);
+	activate_task(this_rq, p, ENQUEUE_PRESERVE_INTERACTIVITY);
+	check_preempt_curr(this_rq, p, 0);
+}
+
+/*
+ * can_migrate_task - may task p from runqueue rq be migrated to this_cpu?
+ */
+static
+int can_migrate_task(struct task_struct *p, struct rq *rq, int this_cpu,
+		     struct sched_domain *sd, enum cpu_idle_type idle,
+		     int *all_pinned)
+{
+	int tsk_cache_hot = 0;
+	/*
+	 * We do not migrate tasks that are:
+	 * 1) running (obviously), or
+	 * 2) cannot be migrated to this CPU due to cpus_allowed, or
+	 * 3) are cache-hot on their current CPU.
+	 */
+	if (!cpumask_test_cpu(this_cpu, &p->cpus_allowed)) {
+		schedstat_inc(p, se.statistics.nr_failed_migrations_affine);
+		return 0;
+	}
+	*all_pinned = 0;
+
+	if (task_running(rq, p)) {
+		schedstat_inc(p, se.statistics.nr_failed_migrations_running);
+		return 0;
+	}
+
+	/*
+	 * Aggressive migration if:
+	 * 1) task is cache cold, or
+	 * 2) too many balance attempts have failed.
+	 */
+
+	tsk_cache_hot = task_hot(p, rq->clock_task, sd);
+	if (!tsk_cache_hot ||
+		sd->nr_balance_failed > sd->cache_nice_tries) {
+#ifdef CONFIG_SCHEDSTATS
+		if (tsk_cache_hot) {
+			schedstat_inc(sd, lb_hot_gained[idle]);
+			schedstat_inc(p, se.statistics.nr_forced_migrations);
+		}
+#endif
+		return 1;
+	}
+
+	if (tsk_cache_hot) {
+		schedstat_inc(p, se.statistics.nr_failed_migrations_hot);
+		return 0;
+	}
+	return 1;
+}
+
+/*
+ * move_one_task tries to move exactly one task from busiest to this_rq, as
+ * part of active balancing operations within "domain".
+ * Returns 1 if successful and 0 otherwise.
+ *
+ * Called with both runqueues locked.
+ */
+static inline int
+move_one_task(struct rq *this_rq, int this_cpu, struct rq *busiest,
+	      struct sched_domain *sd, enum cpu_idle_type idle)
+{
+	struct task_struct *p, *n;
+	struct htfs_rqs *rqs;
+	int pinned = 0;
+
+	for_each_leaf_htfs_rqs(busiest, rqs) {
+		list_for_each_entry_safe(p, n, &rqs->tasks, se.group_node) {
+
+			if (!can_migrate_task(p, busiest, this_cpu,
+						sd, idle, &pinned))
+				continue;
+
+			pull_task(busiest, p, this_rq, this_cpu);
+			/*
+			 * Right now, this is only the second place pull_task()
+			 * is called, so we can safely collect pull_task()
+			 * stats here rather than inside pull_task().
+			 */
+			schedstat_inc(sd, lb_gained[idle]);
+			return 1;
+		}
+	}
+
+	return 0;
+}
+
+static unsigned long
+balance_tasks(struct rq *this_rq, int this_cpu, struct rq *busiest,
+	      unsigned long max_load_move, struct sched_domain *sd,
+	      enum cpu_idle_type idle, int *all_pinned,
+	      int *this_best_prio, struct htfs_rqs *busiest_rqs)
+{
+	int loops = 0, pulled = 0;
+	long rem_load_move = max_load_move;
+	struct task_struct *p, *n;
+
+	if (max_load_move == 0)
+		goto out;
+
+	list_for_each_entry_safe(p, n, &busiest_rqs->tasks, se.group_node) {
+		if (loops++ > sysctl_sched_nr_migrate)
+			break;
+#ifdef HTFS_LOAD_AVG
+		if ((p->se.load_avg >> 1) > rem_load_move ||
+		    !can_migrate_task(p, busiest, this_cpu, sd, idle,
+				      all_pinned))
+			continue;
+#else
+		if ((p->se.load.weight >> 1) > rem_load_move ||
+		    !can_migrate_task(p, busiest, this_cpu, sd, idle,
+				      all_pinned))
+			continue;
+#endif
+
+		pull_task(busiest, p, this_rq, this_cpu);
+		pulled++;
+#ifdef HTFS_LOAD_AVG
+		rem_load_move -= p->se.load_avg;
+#else
+		rem_load_move -= p->se.load.weight;
+#endif
+
+#ifdef CONFIG_PREEMPT
+		/*
+		 * NEWIDLE balancing is a source of latency, so preemptible
+		 * kernels will stop after the first task is pulled to minimize
+		 * the critical section.
+		 */
+		if (idle == CPU_NEWLY_IDLE)
+			break;
+#endif
+
+		/*
+		 * We only want to steal up to the prescribed amount of
+		 * weighted load.
+		 */
+		if (rem_load_move <= 0)
+			break;
+
+		if (p->prio < *this_best_prio)
+			*this_best_prio = p->prio;
+	}
+out:
+	/*
+	 * Right now, this is one of only two places pull_task() is called,
+	 * so we can safely collect pull_task() stats here rather than
+	 * inside pull_task().
+	 */
+	schedstat_add(sd, lb_gained[idle], pulled);
+
+	return max_load_move - rem_load_move;
+}
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+/*
+ * update tg->load_weight by folding this cpu's load_avg
+ */
+static int update_shares_cpu(struct task_group *tg, int cpu)
+{
+	struct htfs_rqs *rqs;
+	unsigned long flags;
+	struct rq *rq;
+
+	if (!tg->se[cpu])
+		return 0;
+
+	rq = cpu_rq(cpu);
+	rqs = tg->htfs_rqs[cpu];
+
+	raw_spin_lock_irqsave(&rq->lock, flags);
+
+	update_rq_clock(rq);
+#ifdef HTFS_OLD_BALANCING
+	update_htfs_load(rqs, 1);
+#else
+	update_htfs_load_contribution(rqs, 1);
+#endif
+
+	/*
+	 * We need to update shares after updating tg->load_weight in
+	 * order to adjust the weight of groups with long running tasks.
+	 */
+	update_htfs_shares(rqs);
+
+	raw_spin_unlock_irqrestore(&rq->lock, flags);
+
+	return 0;
+}
+
+static void update_shares(int cpu)
+{
+	struct htfs_rqs *rqs;
+	struct rq *rq = cpu_rq(cpu);
+
+	rcu_read_lock();
+	for_each_leaf_htfs_rqs(rq, rqs)
+		update_shares_cpu(rqs->tg, cpu);
+	rcu_read_unlock();
+}
+
+/*
+ * Compute the cpu's hierarchical load factor for each task group.
+ * This needs to be done in a top-down fashion because the load of a child
+ * group is a fraction of its parents load.
+ */
+static int tg_load_down(struct task_group *tg, void *data)
+{
+	unsigned long load;
+	long cpu = (long)data;
+
+	if (!tg->parent) {
+		load = cpu_rq(cpu)->load.weight;
+	} else {
+		load = tg->parent->htfs_rqs[cpu]->h_load;
+		load *= tg->se[cpu]->load.weight;
+		load /= tg->parent->htfs_rqs[cpu]->weight + 1;
+	}
+
+	tg->htfs_rqs[cpu]->h_load = load;
+
+	return 0;
+}
+
+static void update_h_load(long cpu)
+{
+	walk_tg_tree(tg_load_down, tg_nop, (void *)cpu);
+}
+
+static inline unsigned long
+load_balance_fair(struct rq *this_rq, int this_cpu, struct rq *busiest,
+		  unsigned long max_load_move,
+		  struct sched_domain *sd, enum cpu_idle_type idle,
+		  int *all_pinned, int *this_best_prio)
+{
+	long rem_load_move = max_load_move;
+	int busiest_cpu = cpu_of(busiest);
+	struct task_group *tg;
+
+	rcu_read_lock();
+	update_h_load(busiest_cpu);
+
+	list_for_each_entry_rcu(tg, &task_groups, list) {
+		struct htfs_rqs *busiest_rqs = tg->htfs_rqs[busiest_cpu];
+		unsigned long busiest_h_load = busiest_rqs->h_load;
+		unsigned long busiest_weight = busiest_rqs->weight;
+		u64 rem_load, moved_load;
+
+		/*
+		 * empty group
+		 */
+		if (&busiest_rqs->tasks == busiest_rqs->tasks.next)
+			continue;
+
+		rem_load = (u64)rem_load_move * busiest_weight;
+		rem_load = div_u64(rem_load, busiest_h_load + 1);
+
+		moved_load = balance_tasks(this_rq, this_cpu, busiest,
+				rem_load, sd, idle, all_pinned, this_best_prio,
+				busiest_rqs);
+
+		if (!moved_load)
+			continue;
+
+		moved_load *= busiest_h_load;
+		moved_load = div_u64(moved_load, busiest_weight + 1);
+
+		rem_load_move -= moved_load;
+		if (rem_load_move < 0)
+			break;
+	}
+	rcu_read_unlock();
+
+	return max_load_move - rem_load_move;
+}
+#else
+static inline void update_shares(int cpu)
+{
+}
+
+static inline unsigned long
+load_balance_fair(struct rq *this_rq, int this_cpu, struct rq *busiest,
+		  unsigned long max_load_move,
+		  struct sched_domain *sd, enum cpu_idle_type idle,
+		  int *all_pinned, int *this_best_prio)
+{
+	return balance_tasks(this_rq, this_cpu, busiest,
+			max_load_move, sd, idle, all_pinned,
+			this_best_prio, &busiest->htfs_rqs);
+}
+#endif
+#endif
+/******************************************************************************
+ * interface task operations
+ */
+
+/*
+ * New task to enqueue on the runqueue
+ */
+static void enqueue_task_htfs(struct rq *rq, struct task_struct *p, int flags)
+{
+	struct htfs_rqs *rqs;
+	struct sched_entity *se = &p->se;
+	int all_inter = 1;
+	if (unlikely(se->load.inv_weight == 0))
+		se->load.inv_weight = calc_inv_weight(se->load.weight);
+	if (flags & (ENQUEUE_WAKEUP | ENQUEUE_WAKING)) {
+		for_each_sched_entity(se) {
+			if (se->on_rq)
+				break;
+			rqs = rqs_of_se(se);
+			se_wakeup_set_vruntime(rqs, se);
+			se->htfs_state = 0;
+			rqs_add(rqs, se);
+			if (all_inter && !se_is_on_interq(se))
+				all_inter = 0;
+		}
+	} else if (flags & ENQUEUE_PRESERVE_INTERACTIVITY) {
+		for_each_sched_entity(se) {
+			if (se->on_rq)
+				break;
+			rqs = rqs_of_se(se);
+			se->vruntime = rqs->vtime;
+			se->htfs_state = 0;
+			rqs_add(rqs, se);
+			if (all_inter && !se_is_on_interq(se))
+				all_inter = 0;
+		}
+	} else {
+		for_each_sched_entity(se) {
+			if (se->on_rq)
+				break;
+			rqs = rqs_of_se(se);
+			se->vruntime = rqs->vtime - (((u64)se->load.inv_weight
+				<< HTFS_STATIC_TIMESLICE_SHIFT)
+				>> (32 - HTFS_VTIME_ACCURACY));
+			se->htfs_state = 0;
+			se->bw_ind = se_find_bw_ind(se) - 1;
+#ifdef HTFS_LOAD_AVG
+			se->load_avg = se->load.weight >> 1;
+#endif
+			se_inter_init(rqs, se);
+			rqs_add(rqs, se);
+			if (all_inter && !se_is_on_interq(se))
+				all_inter = 0;
+		}
+	}
+	if (unlikely(all_inter && sched_feat(WAKEUP_PULL_INTERQ))) {
+		// all entities could be enqueed on the interactive queue...
+		// so we try to move all entities above this to the interactive
+		// queues
+		for_each_sched_entity(se) {
+			rqs = rqs_of_se(se);
+
+			if (!se_is_on_interq(se)) {
+				if (!rqs_se_move_interq(rqs, se))
+					break;
+			}
+#ifdef HTFS_OLD_BALANCING
+			update_htfs_load(rqs, 0);
+#else
+			update_htfs_load_contribution(rqs, 0);
+#endif
+			update_htfs_shares(rqs);
+		}
+	}
+	for_each_sched_entity(se) {
+		rqs = rqs_of_se(se);
+#ifdef HTFS_OLD_BALANCING
+		update_htfs_load(rqs, 0);
+#else
+		update_htfs_load_contribution(rqs, 0);
+#endif
+		update_htfs_shares(rqs);
+	}
+
+}
+
+/*
+ * Remove a task from the runqueue
+ */
+static void dequeue_task_htfs(struct rq *rq, struct task_struct *p, int flags)
+{
+	struct sched_entity *se = &p->se;
+	struct htfs_rqs *rqs;
+	if (rq->continue_run == p) {
+		rq->continue_run = NULL;
+	}
+	for_each_sched_entity(se) {
+		rqs = rqs_of_se(se);
+		rqs_del(rqs, se);
+		if (rqs->nr_running) {
+			if (unlikely(!rqs->interq.bweight && sched_feat(WAKEUP_PULL_INTERQ)))
+				goto interq_empty;
+			else
+				break;
+		}
+	}
+	if (0) {
+		// Lets remove the entities in the above hierarchy from
+		// the interq if there is no real interactive task anymore
+		for_each_sched_entity(se) {
+			rqs = rqs_of_se(se);
+			
+			if (se_is_on_interq(se)) {
+				if (!rqs_se_move_normalq(rqs, se))
+					return;
+			} else {
+				break;
+			}
+
+			if (rqs->interq.bweight)
+				break;
+interq_empty:
+#ifdef HTFS_OLD_BALANCING
+			update_htfs_load(rqs, 0);
+#else
+			update_htfs_load_contribution(rqs, 0);
+#endif
+			update_htfs_shares(rqs);
+		}
+	}
+	for_each_sched_entity(se) {
+		rqs = rqs_of_se(se);
+
+#ifdef HTFS_OLD_BALANCING
+		update_htfs_load(rqs, 0);
+#else
+		update_htfs_load_contribution(rqs, 0);
+#endif
+		update_htfs_shares(rqs);
+	}
+}
+
+static struct task_struct *pick_next_task_htfs(struct rq *rq)
+{
+	struct htfs_rqs *rqs = &rq->htfs_rqs;
+	struct sched_entity *se;
+	u64 slice;
+	int inter_entity = 0;
+	if (unlikely(rqs->nr_running == 0)) {
+		return NULL;
+	}
+	if (rq->continue_run) {
+		struct task_struct *to_run = rq->continue_run;
+		rq->continue_run = NULL;
+		return to_run;
+	}
+	if (rq->slice_remain < sched_inter_slice) {
+		rq->slice_remain = rq->slice;
+		slice = rq->slice;
+		do {
+			se = rqs_pick_next_full_slice(rq, rqs, &inter_entity);
+			se_start_exec(se, rq);
+			if (unlikely(inter_entity))
+				goto changed_to_inter;
+#ifdef CONFIG_FAIR_GROUP_SCHED
+			rqs = se->my_q;
+#else
+			break;
+#endif
+		} while(rqs);
+	} else {
+		// We have obviously a fraction of a complete timeslice remaining
+		// Now we are giving the remaining to other interactive tasks
+		do {
+			se = rqs_pick_next_inter_slice(rq, rqs, &inter_entity);
+			se_start_exec(se, rq);
+changed_to_inter:
+#ifdef CONFIG_FAIR_GROUP_SCHED
+			rqs = se->my_q;
+#else
+			break;
+#endif
+		} while(rqs);
+		if (inter_entity)
+			slice = sched_inter_slice;
+		else
+			slice = rq->slice_remain;
+	}
+	rq->slice_granted = slice;
+#ifdef CONFIG_SCHED_HRTICK
+	if (hrtick_enabled(rq))
+		hrtick_start(rq, slice);
+#endif
+	return task_of(se);
+}
+
+#define HTFS_SAME_CALL_DIFF (1UL << 5)
+#define HTFS_SMALL_DIFF (1UL << 8)
+#define HTFS_MAX_CONTINUES 20
+
+static void put_prev_task_htfs(struct rq *rq, struct task_struct *prev)
+{
+	struct htfs_rqs *rqs;
+	struct sched_entity *se = &prev->se;
+	s64 min_remaining = rq->slice_granted;
+	s64 remain = 0;
+	u64 call_diff = rq->clock - rq->last_call;
+	rq->last_call = rq->clock;
+	if (likely(sched_feat(PROB_RERUN))) {
+		if (rq->force_sched) {
+			rq->force_sched = 0;
+			goto resched;
+		}
+		for_each_sched_entity(se) {
+			if (!se->on_rq) {
+				rq->call_time_diff = 0;
+				return;
+			}
+			remain = se_update_runtime(se, rq);
+			if (min_remaining > remain)
+				min_remaining = remain;
+		}
+		if (min_remaining <= 0) {
+			goto resched;
+		}
+		if (unlikely(rq->continues >= HTFS_MAX_CONTINUES)) {
+			goto resched;
+		} else if (unlikely(abs((s64)call_diff - rq->call_time_diff)
+				< HTFS_SAME_CALL_DIFF)) {
+			goto resched;
+		} else if (unlikely(call_diff < HTFS_SMALL_DIFF)) {
+			goto resched;
+		}
+		goto continue_run;
+	}
+resched:
+	rq->call_time_diff = 0;
+	rq->continues = 0;
+	se = &prev->se;
+	for_each_sched_entity(se) {
+		rqs = rqs_of_se(se);
+		rqs_update_load_avg(rqs);
+		rqs_reenqueue(rqs, se);
+	}
+	return;
+
+continue_run:
+	rq->call_time_diff = call_diff;
+	rq->continue_run = prev;
+	++rq->continues;
+#ifdef CONFIG_SCHED_HRTICK
+	if (hrtick_enabled(rq))
+		hrtick_start(rq, min_remaining);
+#endif
+	return;
+}
+
+static void yield_task_htfs(struct rq *rq)
+{
+	// TODO: perhaps push the interactivity more?
+}
+
+static void check_preempt_wakeup(struct rq *rq, struct task_struct *p, int flags)
+{
+	// TODO... interrupt only long running tasks and so on...
+	// specify a special task for next run from interq?
+	struct task_struct *curr = rq->curr;
+	struct sched_entity *se = &curr->se, *pse = &p->se;
+	s64 remaining = se_update_runtime(se, rq);
+
+	if (unlikely(se == pse))
+		return;
+
+	/*
+	 * The currently running task is obviously a interactive task
+	 */
+	if (rq->slice_granted == sched_inter_slice)
+		return;
+	/*
+	 * don't preempt if the remaining slice is smaller than the interactive
+	 * timeslice
+	 */
+	if (remaining < sched_inter_slice)
+		return;
+	/*
+	 * We can come here with TIF_NEED_RESCHED already set from new task
+	 * wake up path.
+	 */
+	if (test_tsk_need_resched(curr))
+		return;
+
+	/*
+	 * Batch and idle tasks do not preempt (their preemption is driven by
+	 * the tick):
+	 */
+	if (unlikely(p->policy != SCHED_NORMAL))
+		return;
+
+	/* Idle tasks are by definition preempted by everybody. */
+	if (unlikely(curr->policy == SCHED_IDLE))
+		goto preempt;
+
+	if (!sched_feat(WAKEUP_PREEMPT))
+		return;
+
+preempt:
+	for_each_sched_entity(se) {
+		se->htfs_state |= HTFS_PREEMPTED;
+	}
+	rq->force_sched = 1;
+	resched_task(curr);
+}
+
+static void set_curr_task_htfs(struct rq *rq)
+{
+	// nothing to do because all calls to this function are after the call
+	// of dequeue_task...
+	// further running shouldn't make any problems
+}
+
+
+static void slice_dec(struct rq *rq)
+{
+	if (rq->slice_shift != sysctl_sched_inter_slice_shift) {
+		--rq->slice_shift;
+		rq->slice = (1UL << rq->slice_shift);
+	}
+	rq->slice_change_last = rq->clock;
+}
+
+static void slice_inc(struct rq *rq)
+{
+	if (rq->slice_shift != sysctl_sched_slice_max_shift) {
+		++rq->slice_shift;
+		rq->slice = (1UL << rq->slice_shift);
+	}
+	rq->slice_change_last = rq->clock;
+}
+
+#define HTFS_SLICE_SHRINK_THR 1
+#define HTFS_SLICE_SHRINK_DEC_INT 10000000UL
+#define HTFS_SLICE_INC_AFTER 100000000UL
+
+static void task_tick_htfs(struct rq *rq, struct task_struct *p, int queued)
+{
+	struct sched_entity *se = &p->se;
+	struct htfs_rqs *rqs = &rq->htfs_rqs;
+	s64 min_remaining = rqs->rq->slice_granted;
+	if (likely(sched_feat(DYNAMIC_TIMESLICE))) {
+		if (rq->slice_shrink > HTFS_SLICE_SHRINK_THR) {
+			rq->slice_shrink = 0;
+			rq->slice_shrink_last_dec = rq->clock;
+			slice_dec(rq);
+		} else if ((s64) (rq->clock - rq->slice_shrink_last_dec) >
+				HTFS_SLICE_SHRINK_DEC_INT) {
+			if (!rq->slice_shrink && rq->clock - rq->slice_change_last
+					> HTFS_SLICE_INC_AFTER) {
+				slice_inc(rq);
+			}
+			rq->slice_shrink >>= 1;
+			rq->slice_shrink_last_dec = rq->clock;
+		}
+	}
+/*	if (++rqs->dbg_counter == 25) {
+		rqs->dbg_counter = 0;
+		rqs_dump(rqs, 0);
+	}*/
+	//TODO don't reschedule with only one task active
+	for_each_sched_entity(se) {
+		update_entity_shares_tick(rqs_of_se(se));
+	}
+#ifdef CONFIG_SCHED_HRTICK
+	if (queued) {
+		rq->force_sched = 1;
+		resched_task(rq->curr);
+		return;
+	}
+	if (!sched_feat(DOUBLE_TICK) &&
+			hrtimer_active(&rq->hrtick_timer))
+		return;
+#endif
+	se = &p->se;
+	for_each_sched_entity(se) {
+		s64 remaining = se_update_runtime(se, rq);
+		min_remaining = min(min_remaining, remaining);
+	}
+	if (min_remaining <= 0) {
+		rq->force_sched = 1;
+		resched_task(rq->curr);
+	}
+}
+
+static void switched_to_htfs(struct rq *this_rq, struct task_struct *task,
+			     int running)
+{
+	if (running) {
+		this_rq->force_sched = 1;
+		resched_task(this_rq->curr);
+	}
+}
+
+static void prio_changed_htfs(struct rq *this_rq, struct task_struct *task,
+			     int oldprio, int running)
+{
+}
+
+static unsigned int get_rr_interval_htfs(struct rq *rq, struct task_struct *task)
+{
+	return NS_TO_JIFFIES(rqs_of_se(&task->se)->rq->slice);
+}
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+static void task_move_group_htfs(struct task_struct *p, int on_rq)
+{
+	p->se.vruntime -= rqs_of_se(&p->se)->vtime;
+	set_task_rq(p, task_cpu(p));
+	p->se.vruntime += rqs_of_se(&p->se)->vtime;
+}
+#endif
+
+/*static void task_fork_fair(struct task_struct *p)
+{
+	int this_cpu = smp_processor_id();
+	struct rq *rq = this_rq();
+	unsigned long flags;
+
+	raw_spin_lock_irqsave(&rq->lock, flags);
+
+	rq->force_sched = 1;
+	resched_task(rq->curr);
+
+	if (unlikely(task_cpu(p) != this_cpu)) {
+		rcu_read_lock();
+		__set_task_cpu(p, this_cpu);
+		rcu_read_unlock();
+	}
+
+	raw_spin_unlock_irqrestore(&rq->lock, flags);
+}*/
+
+static const struct sched_class fair_sched_class = {
+	.next			= &idle_sched_class,
+	.enqueue_task		= enqueue_task_htfs,
+	.dequeue_task		= dequeue_task_htfs,
+	.yield_task		= yield_task_htfs,
+
+	.check_preempt_curr	= check_preempt_wakeup,
+
+	.pick_next_task		= pick_next_task_htfs,
+	.put_prev_task		= put_prev_task_htfs,
+
+#ifdef CONFIG_SMP
+	.select_task_rq		= select_task_rq_fair,
+	.rq_online		= rq_online_fair,
+	.rq_offline		= rq_offline_fair,
+
+#endif
+
+	.set_curr_task          = set_curr_task_htfs,
+	.task_tick		= task_tick_htfs,
+//	.task_fork		= task_fork_fair,
+
+	.prio_changed		= prio_changed_htfs,
+	.switched_to		= switched_to_htfs,
+
+	.get_rr_interval	= get_rr_interval_htfs,
+
+#ifdef CONFIG_FAIR_GROUP_SCHED
+	.task_move_group	= task_move_group_htfs,
+#endif
+};
+
+
+#ifdef CONFIG_SCHED_DEBUG
+
+extern void print_htfs_rqs(struct seq_file *m, int cpu, struct htfs_rqs *rqs);
+
+static void print_htfs_stats(struct seq_file *m, int cpu)
+{
+	struct htfs_rqs *rqs;
+
+	rcu_read_lock();
+	for_each_leaf_htfs_rqs(cpu_rq(cpu), rqs)
+		print_htfs_rqs(m, cpu, rqs);
+	rcu_read_unlock();
+}
+#endif
+
+#endif /* CONFIG_SCHED_FAIR_HTFS */
